--- vlc.win32.nsi.in	Sat Sep 22 14:32:40 2007
+++ vlc.win32.nsi.in	Sat Sep 22 16:07:02 2007
@@ -226,16 +226,22 @@
 ;;;;;;;;;;;;;;;;;;;;;;;;
 
 !macro AddContextMenu EXT
-  WriteRegStr HKCR ${EXT}\shell\PlayWithVLC "" "Play with VLC media player"
-  WriteRegStr HKCR ${EXT}\shell\PlayWithVLC\command "" '$INSTDIR\vlc.exe --started-from-file --no-playlist-enqueue "%1"'
-
-  WriteRegStr HKCR ${EXT}\shell\AddToPlaylistVLC "" "Add to VLC media player's Playlist"
-  WriteRegStr HKCR ${EXT}\shell\AddToPlaylistVLC\command "" '$INSTDIR\vlc.exe --started-from-file --playlist-enqueue "%1"'
+  Push $R0
+  ReadRegStr $R0 HKCR ${EXT} ""
+  WriteRegStr HKCR $R0\shell\PlayWithVLC "" "Play with VLC media player"
+  WriteRegStr HKCR $R0\shell\PlayWithVLC\command "" '$INSTDIR\vlc.exe --started-from-file --no-playlist-enqueue "%1"'
+
+  WriteRegStr HKCR $R0\shell\AddToPlaylistVLC "" "Add to VLC media player's Playlist"
+  WriteRegStr HKCR $R0\shell\AddToPlaylistVLC\command "" '$INSTDIR\vlc.exe --started-from-file --playlist-enqueue "%1"'
+  Pop $R0
 !macroend
 
 !macro DeleteContextMenu EXT
-  DeleteRegKey HKCR ${EXT}\shell\PlayWithVLC
-  DeleteRegKey HKCR ${EXT}\shell\AddToPlaylistVLC
+  Push $R0
+  ReadRegStr $R0 HKCR ${EXT} ""
+  DeleteRegKey HKCR $R0\shell\PlayWithVLC
+  DeleteRegKey HKCR $R0\shell\AddToPlaylistVLC
+  Pop $R0
 !macroend
 
 ;;;;;;;;;;;;;;;;;;;;;;;;;;
@@ -492,12 +498,6 @@
   RegDLL "$INSTDIR\axvlc.dll"
 SectionEnd
 
-Section /o "Context Menus" SEC05
-  SectionIn 3
-  !insertmacro MacroAllExtensions AddContextMenu
-  !insertmacro AddContextMenu "Directory"
-SectionEnd
-
 SectionGroup "File type associations" SEC06
   SectionGroup "Audio Files"
     !insertmacro MacroAudioExtensions RegisterExtensionSection
@@ -509,6 +509,12 @@
     !insertmacro MacroOtherExtensions RegisterExtensionSection
   SectionGroupEnd
 SectionGroupEnd
+
+Section /o "Context Menus" SEC05
+  SectionIn 3
+  !insertmacro MacroAllExtensions AddContextMenu
+  !insertmacro AddContextMenu "Directory"
+SectionEnd
 
 Section /o "Delete preferences and cache" SEC07
   !insertmacro delprefs
